SystemOrganization addCategory: #DijEvolution!

!Integer methodsFor: '*DijEvolution' stamp: 'hjo 6/27/2012 15:03'!
multiply: aSmallInteger modulo: aSmallInteger2 

	^(self * aSmallInteger) \\ aSmallInteger2! !

Object subclass: #DijEvolution
	instanceVariableNames: 'ancestors costSortedObjects children leastCostLife'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 16:37'!
addChildrenToCostSortedObjects

	costSortedObjects addAll: children.! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 16:31'!
addSeed: anObject

	costSortedObjects add: (DijLife object: anObject cost: 0).! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 13:49'!
ancestors

	^ ancestors! !

!DijEvolution methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:51'!
costSortedObjects

	^ costSortedObjects! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 16:35'!
dropChildren

	| ancestorObjects |
	ancestorObjects := ancestors collect: [:each| each object ]. 
	children := children reject: [:ch| ancestorObjects includes: ch object ]! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 16:59'!
getLeastCostLifeFromSorted
	leastCostLife := costSortedObjects removeFirst.! !

!DijEvolution methodsFor: 'initialize-release' stamp: 'hjo 6/27/2012 16:30'!
initialize

	super initialize.
	ancestors := OrderedCollection new. "should be Set?"
	costSortedObjects := SortedCollection sortBlock: [:minClub1 :minClub2| minClub1 cost <= minClub2 cost ].! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 17:00'!
jionLeastCostLifeToAncestors
	ancestors addLast: leastCostLife.! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 14:17'!
leastCostObject

	^costSortedObjects first! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 16:44'!
leaveLeastCostDijLifeIfTheyShareEqualObjects

	| livesSharingEqualObjects |
	livesSharingEqualObjects := (costSortedObjects groupBy: #object) associations select: [:each| each value size > 1 ].
	livesSharingEqualObjects do: [:each| each shouldBeImplemented ].! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 17:01'!
makeChildren
	children := 
		{	leastCostLife giveBirthWith: (Message selector: #multiply:modulo: arguments: #(2 17)).
			leastCostLife giveBirthWith: (Message selector: #multiply:modulo: arguments: #(3 17))	}.
! !

!DijEvolution methodsFor: 'stepping and presenter' stamp: 'hjo 6/27/2012 17:02'!
step

	self getLeastCostLifeFromSorted.
	self jionLeastCostLifeToAncestors.
	self makeChildren.
	self dropChildren.
	self addChildrenToCostSortedObjects.
	self leaveLeastCostDijLifeIfTheyShareEqualObjects.
! !

Object subclass: #DijLife
	instanceVariableNames: 'origin birthMessage birthCost cost object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijLife classSide methodsFor: 'instance creation' stamp: 'hjo 6/27/2012 14:18'!
object: anObject 

	^self new object: anObject! !

!DijLife classSide methodsFor: 'instance creation' stamp: 'hjo 6/27/2012 14:18'!
object: anObject cost: aNumber

	^self new object: anObject; cost: aNumber! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthCost
	^ birthCost! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthCost: anObject
	birthCost := anObject! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthMessage
	^ birthMessage! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthMessage: anObject
	birthMessage := anObject! !

!DijLife methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 14:59'!
computeCost

	cost := origin cost + birthCost.! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost
	^ cost! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost: aNumber
	cost := aNumber
! !

!DijLife methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 15:03'!
giveBirthWith: aMessage 

	^self species new 
		origin: self;
		birthMessage: aMessage;
		birthCost: 1;
		object: (aMessage sendTo: object);
		computeCost  ! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 14:50'!
object

	^ object! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:57'!
object: anObject 

	object := anObject! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
origin
	^ origin! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
origin: anObject
	origin := anObject! !
